#include "circuit.h"

#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include "assert.h"
#include <chrono>


bool Circuit::local_search(std::unordered_set<Fault*> &faults) {

    // 随机生成初始电路
    ls_init_circuit(faults);

    // print_gates();

    printf("generate random circuit done!\n");

    srand(19260817);

    int T = 10000000;
    while(T--) {

        printf("%d\n", T);

        // print_gates();

        // int score_1 = check_circuit();

        int i = rand()%gates.size();
        Gate* flip_gate = gates[i];

        int dert = flip_gate->score;

        // printf("svuc: %d, sfpw: %d, sfpuc: %d, sfdw: %d, sfduc: %d  <<<\n", 
        // flip_gate->score_value_unsatisfied_cost, 
        // flip_gate->score_fault_propagated_weight[0] + flip_gate->score_fault_propagated_weight[1], 
        // flip_gate->score_fault_propagated_unsatisfied_cost[0] + flip_gate->score_fault_propagated_unsatisfied_cost[1],
        // flip_gate->score_fault_detected_weight[0] + flip_gate->score_fault_detected_weight[1],
        // flip_gate->score_fault_detected_unsatisfied_cost[0] + flip_gate->score_fault_detected_unsatisfied_cost[1]);

        ls_flip(flip_gate);

        // int score_2 = check_circuit();
        // printf("checking circuit: %d %d\n", score_2 - score_1, dert);

        // assert((score_2 - score_1) ==  dert);
        // printf("i: %s\n", flip_gate->name.c_str());
    }

    exit(0);
    
    //printf("local search!\n");

    while(true) {
        Gate* gate = ls_pick();
        if(gate == nullptr) {
            break;
        }
    }

    static int original_faults = -1;
    if(original_faults == - 1) {
        original_faults = faults.size();
    }
    static int pattern = 0;

    std::unordered_set<Fault*> tmp = faults;

    for(Fault* f : tmp) {
        if(f->gate->fault_detected[f->type]) {
            faults.erase(f);
        }
    }

    if(tmp.size() == faults.size()) pattern--;

    printf("coverage: %.3f%%\tpattern: %d\tbefore: %d\tnow: %d\n", (double)(original_faults - faults.size()) / (original_faults) * 100, ++pattern, tmp.size(), faults.size());

    if(tmp.size() == faults.size()) return false;

    return true;
}

Gate* Circuit::ls_pick() {
    return nullptr;
}

void Circuit::ls_flip(Gate* gate) {

    printf("flip: %s\n", gate->name.c_str());

    gate->value ^= 1;
    gate->update_gate_property();

    gate->update_gate_statistics();

    for(Gate* g : gate->fanouts) {
        g->update_gate_statistics();
    }
    for(Gate* g : gate->reigon) {
        g->update_gate_statistics();
    }

    gate->score = gate->cal_score();

    int cal_cnt = 0;

    for(Gate* g : gate->fanouts) {
        g->score = g->cal_score();
    }

    for(Gate* g : gate->reigon) {
        g->score = g->cal_score();
    }

    for(Gate* g : gate->fanins) {
        g->score = g->cal_score();
        for(Gate* out : g->fanouts) {
            out->score = out->cal_score();
        }
    }

    for(Gate* g : gates) {
        if(g->score != g->cal_score(true) ){
            printf("bug3: %s\n", g->name.c_str());
            // print_gates();
            exit(0);
        }
    }

    // exit(0);

    // printf("bug %s: cal_len:%d len:%d\n", gate->name.c_str(), gate->cal_propagate_len(1), gate->fault_propagated_len[1]);
}

void Circuit::ls_update_weight() {


}

void Circuit::ls_update(Gate* stem) {


}

void Circuit::ls_init_circuit(std::unordered_set<Fault*> &faults) {

    // init value, weight and cost
    for(Gate* g : gates) {
        g->value = rand() % 2;
        g->fault_need_update = 0;
        g->value_unsatisfied_cost = 1;
        g->fault_need_update_cost = 1;
        g->fault_propagated_weight[0] = g->fault_propagated_weight[1] = 0;
        g->fault_detected_weight[0] = g->fault_detected_weight[1] = 0;
    }

    for(Fault* f : faults) {
        f->gate->fault_propagated_weight[f->type] = 1;
        f->gate->fault_detected_weight[f->type] = 1;
    }

    for(Gate* g : rtopo_gates) {
        g->update_gate_property();
    }

    for(Gate* g : rtopo_gates) {
        g->update_gate_statistics();
    }

    // cal score
    for(Gate* g : gates) {
        g->score = g->cal_score();
        printf("%d ", g->score);
    }

}