#include "circuit.h"


int Gate::cal_score(int debug) {

    value ^= 1;

    // if(debug) {
    //     // printf("lala: %s\n", this->name.c_str());
    //     assert(score_value_unsatisfied_cost == cal_value_unsatisfied_cost());
    //     assert(score_fault_propagated_weight[0] == cal_score_fault_propagated_weight(0));
    //     assert(score_fault_propagated_weight[1] == cal_score_fault_propagated_weight(1));
    //     assert(score_fault_propagated_unsatisfied_cost[0] == cal_score_fault_propagated_unsatisfied_cost(0));
    //     assert(score_fault_propagated_unsatisfied_cost[1] == cal_score_fault_propagated_unsatisfied_cost(1));
    //     assert(score_fault_detected_weight[0] == cal_score_fault_detected_weight(0));
    //     assert(score_fault_detected_weight[1] == cal_score_fault_detected_weight(1));
    //     assert(score_fault_detected_unsatisfied_cost[0] == cal_score_fault_detected_unsatisfied_cost(0));
    //     assert(score_fault_detected_unsatisfied_cost[1] == cal_score_fault_detected_unsatisfied_cost(1));
    // }

    int origin_fault_detected[2];
    origin_fault_detected[0] = this->fault_detected[0];
    origin_fault_detected[1] = this->fault_detected[1];
    this->fault_detected[0] = this->cal_fault_detected(0);
    this->fault_detected[1] = this->cal_fault_detected(1);

    int origin_fault_propagated_len[2];
    origin_fault_propagated_len[0] = this->fault_propagated_len[0];
    origin_fault_propagated_len[1] = this->fault_propagated_len[1];
    this->fault_propagated_len[0] = this->cal_propagate_len(0);
    this->fault_propagated_len[1] = this->cal_propagate_len(1);

    score_value_unsatisfied_cost = cal_value_unsatisfied_cost();
    score_fault_propagated_weight[0] = cal_score_fault_propagated_weight(0);
    score_fault_propagated_weight[1] = cal_score_fault_propagated_weight(1);

    score_fault_detected_weight[0] = cal_score_fault_detected_weight(0);
    score_fault_detected_weight[1] = cal_score_fault_detected_weight(1);

    score_fault_update_cost = cal_score_fault_update_cost();

    value ^= 1;
    this->fault_propagated_len[0] = origin_fault_propagated_len[0];
    this->fault_propagated_len[1] = origin_fault_propagated_len[1];
    this->fault_detected[0] = origin_fault_detected[0];
    this->fault_detected[1] = origin_fault_detected[1];

    return - score_value_unsatisfied_cost - score_fault_update_cost
    + score_fault_propagated_weight[0] + score_fault_propagated_weight[1]
    + score_fault_detected_weight[0] + score_fault_detected_weight[1];
}

int Gate::cal_value_unsatisfied_cost() {
    int res = 0;
    for(Gate* g : fanouts) {
        if(g->value_satisfied && g->cal_value() != g->value) {
            res += g->value_unsatisfied_cost;
        }
        if(!g->value_satisfied && g->cal_value() == g->value) {
            res -= g->value_unsatisfied_cost;
        }
    }
    if(this->value_satisfied && this->cal_value() != this->value) {
        res += this->value_unsatisfied_cost;
    }
    if(!this->value_satisfied && this->cal_value() == this->value) {
        res -= this->value_unsatisfied_cost;
    }
    return res;
}

int Gate::cal_score_fault_propagated_weight(int sa) {
    int res = 0;
    res += (this->cal_propagate_len(sa) - this->fault_propagated_len[sa] ) * this->fault_propagated_weight[sa];
    return res;
}

int Gate::cal_score_fault_detected_weight(int sa) {
    int res = 0;
    res += ( this->cal_fault_detected(sa) - this->fault_detected[sa] ) * this->fault_detected_weight[sa];
    return res;
}

int Gate::cal_score_fault_update_cost() {
    int res = 0;

    if(this->fault_need_update) {
        res -= this->fault_need_update_cost;
    }

    for(Gate* g : fanins) {
        bool changed = 0;
        if(!changed && g->cal_fault_detected(0) != g->fault_detected[0]) changed = 1;
        if(!changed && g->cal_fault_detected(1) != g->fault_detected[1]) changed = 1;
        if(!changed && g->cal_propagate_len(0) != g->fault_propagated_len[0]) changed = 1;
        if(!changed && g->cal_propagate_len(1) != g->fault_propagated_len[1]) changed = 1;

        if(!g->fault_need_update && changed) {
            res += g->fault_need_update_cost;
        }
    }

    return res;
    
}